package swtbotforrequality;


import org.eclipse.swtbot.eclipse.finder.SWTWorkbenchBot;
import org.eclipse.swtbot.swt.finder.SWTBot;
import org.eclipse.swtbot.swt.finder.waits.Conditions;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotShell;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotTree;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;


public class AddToSVN {
	private static SWTWorkbenchBot	bot;
	private static String projectName = "reqProject1";
	private String svnURL = "https://GAULOISES.intra.ispras.ru:8443/svn/MainRepo";
	//private String svnURL = "http://forge.ispras.ru/svn/reqdb/sandbox";
	private String login = "Vika";
	private String pass = "Vika";
	 
	@BeforeClass
	public static void beforeClass() throws Exception {
		bot = new SWTWorkbenchBot();
		//---
		bot.viewByTitle("Welcome").close();
		bot.menu("File").menu("New").menu("Other...").click();
		 
		SWTBotShell shell = bot.shell("New");
		shell.activate();
		bot.tree().expandNode("Requality").select("Requality Project");
		bot.button("Next >").click();
		bot.textWithLabel("Project name:").setText(projectName);
		bot.button("Finish").click();
		bot.activeView();
		//---
	}
 
 
	@Test
	public void canAddProjectToSVN() throws Exception {
		SWTBotTree tree = bot.viewByTitle("Requality Explorer").bot().tree();
		tree.select(projectName);
		ContextMenuHelper.clickContextMenu(tree, "Team", "Share Project...");
		bot.shell("Share Project").bot().tableWithLabel("Select a repository type:").select("SVN");
		bot.shell("Share Project").bot().button("Next >").click();
		//bot.shell("Share Project Wizard").bot().radio("Create a new repository location").click();
		//bot.shell("Share Project Wizard").bot().button("Next >").click();
		SWTBot shareBot = bot.shell("Share Project Wizard").bot();
		shareBot.tabItem("General").setFocus();
		shareBot.comboBoxWithLabel("URL:").setText(svnURL);
		shareBot.comboBoxWithLabel("User:").setText(login);
		shareBot.textWithLabel("Password:").setText(pass);
		shareBot.button("Next >").click();
		bot.waitUntil(Conditions.shellIsActive("Certificate Problem"), 5000);
		for(SWTBotShell sh : bot.shells()) {
			System.out.println(sh.getText());
			if(sh.getText().equals("Certificate Problem")) {
				bot.shell("Certificate Problem").bot().button("Trust").click();
			}
		}
		bot.waitUntil(Conditions.shellIsActive("Share Project Wizard"));
		
		bot.shell("Share Project Wizard").bot().button("Next >").click();
		bot.shell("Share Project Wizard").bot().button("Finish").click();
		bot.waitUntil(Conditions.shellIsActive("Commit"));		
	}
 
 
	@AfterClass
	public static void sleep() {
		bot.sleep(2000);
	}
}
