package swtbotforrequality;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import org.eclipse.swtbot.eclipse.finder.SWTWorkbenchBot;
import org.eclipse.swtbot.eclipse.finder.widgets.SWTBotEditor;
import org.eclipse.swtbot.swt.finder.SWTBot;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotShell;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotText;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotTree;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotTreeItem;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;


public class ChangeRequirementId {
	private static SWTWorkbenchBot	bot;
	 
	@BeforeClass
	public static void beforeClass() throws Exception {
		bot = new SWTWorkbenchBot();
		bot.viewByTitle("Welcome").close();
		bot.menu("File").menu("New").menu("Other...").click();
		 
		SWTBotShell shell = bot.shell("New");
		shell.activate();
		bot.tree().expandNode("Requality").select("Requality Project");
		bot.button("Next >").click();
		bot.textWithLabel("Project name:").setText("ReqProject");
		bot.button("Finish").click();
		bot.activeView();
		SWTBotTree tree = bot.viewByTitle("Requality Base Explorer").bot().tree();
		tree.expandNode("ReqProject").getNode("Requirements").contextMenu("Add requirement...").click();
	}
 
 
	@Test
	public void canChangeRequirementId() throws Exception {
		SWTBot reqEditor = bot.editorByTitle("01").bot();
		SWTBotText id = reqEditor.text("01", 0);
		id.setText("new01");
		bot.shell("Requality - Requirement - Eclipse SDK").activate();
		bot.menu("File").menu("Save").click();
		boolean ok = false;
		for( SWTBotEditor ed: bot.editors()) {
			if(ed.getTitle().equals("new01")) {
				ok = true;
			} else {
				break;
			}
		}
		assertTrue("There is no 'new name' editor", ok);
		reqEditor = bot.editorByTitle("new01").bot();
		assertEquals("ID of requirement is not 'new01'","new01",id.getText());
		SWTBotTree tree = bot.viewByTitle("Requality Base Explorer").bot().tree();
		SWTBotTreeItem node = tree.expandNode("ReqProject").expandNode("Requirements");
		//Conditions.
		//Conditions.treeHasRows(tree.getTreeItem("ReqProject").no, 1);
		assertTrue("There is not 'new01' requirements node in the tree", node.getNodes().contains("new01"));
	}
 
 
	@AfterClass
	public static void sleep() {
		bot.sleep(2000);
	}
}
